#include <stdio.h>
#include <time.h>
#include "Aleatorio.h"

#define TAMANO 10

//Define el arreglo unidimensional de caminos
unsigned int iCamino[TAMANO];
	
//Define la matriz de costos
unsigned int iMatriz[TAMANO][TAMANO];

void main(void);
unsigned int iCalculaCostoCamino(void);

void main()
{
	//Inicializa el generador de nmeros aleatorios
	Aleatorio objAzar;
	time_t ltime1;
	time(&ltime1);
	objAzar.sgenrand(ltime1);

	//Llena la matriz de costos con nmeros al azar entre 10 y 40
	for(unsigned int iPosX=0; iPosX<TAMANO; iPosX++)
	{
		for (unsigned int iPosY=0; iPosY<TAMANO; iPosY++)
		{
			iMatriz[iPosY][iPosX]= (unsigned int) objAzar.genrand()%(40-10+1)+10;
			if (iPosY==iPosX) iMatriz[iPosY][iPosX]= 0;
			printf("%d ", iMatriz[iPosY][iPosX]);
		}
		printf("\n");
	}

	//Llena el arreglo unidimensional de caminos
	for (int iGenera=0; iGenera<TAMANO; iGenera++)
		iCamino[iGenera]=iGenera;

	//Ciclo en el cual intercambia los valores del camino
	unsigned int iCostoOriginal, iCostoFinal;
	for (unsigned int iPruebas=1; iPruebas<=10000; iPruebas++)
	{
		//Calcula el costo original del camino
		iCostoOriginal = iCalculaCostoCamino();
		
		//Hace un intercambio al azar
		unsigned int iSitioA = objAzar.genrand()%TAMANO;
		unsigned int iSitioB = objAzar.genrand()%TAMANO;
	
		unsigned int iTemporal = iCamino[iSitioA];
		iCamino[iSitioA] = iCamino[iSitioB];
		iCamino[iSitioB] = iTemporal;

		//Calcula el nuevo costo con el nuevo camino
		iCostoFinal = iCalculaCostoCamino();

		if (iCostoFinal<iCostoOriginal)
		{
			for (int iGenera=0; iGenera<TAMANO; iGenera++)
				printf("%d->", iCamino[iGenera]);
			printf(" Peso:%d\n", iCostoFinal);
		}
		else //Deja como estaba el camino anteriormente
		{
			unsigned int iTemporal = iCamino[iSitioA];
			iCamino[iSitioA] = iCamino[iSitioB];
			iCamino[iSitioB] = iTemporal;
		}
	}
	getchar();
}

//Calcula el costo del camino seleccionado
unsigned int iCalculaCostoCamino()
{
	unsigned int iCostoTotal=0;
	for (int iGenera=0; iGenera<TAMANO-1; iGenera++)
	{
		int iOrigen = iCamino[iGenera];
		int iDestino = iCamino[iGenera+1];
		iCostoTotal+=iMatriz[iOrigen][iDestino];
	}
	return iCostoTotal;
}

